
//Inkluderer to bibeliotek som trengs for å pubilisere til ROS
#include <ros.h>
#include <std_msgs/Bool.h>


ros::NodeHandle nh;

std_msgs::Bool pushed_msg;
ros::Publisher /raspberry_bot/crashSensor("/raspberry_bot/crashSensor", &pushed_msg);

//Definerer en inngang til hver knapp
const int Knapp1 = 2;
const int Knapp2 = 3;
const int Knapp3 = 4;
const int Knapp4 = 5;
const int Knapp5 = 6;
const int Knapp6 = 7;
const int Knapp7 = 8;
const int Knapp8 = 9;
const int Knapp9 = 10;

//Definerer variabler 
bool last_reading = false;
long last_debounce_time=0;
long debounce_delay=50;
bool published = true;
bool EnBryterPresset = false;

void setup()
{
  nh.initNode();
  nh.advertise(/raspberry_bot/crashSensor);
  
  //Definerer at pinnene på Arduinoen skal være en inngang
  //Definerer også at inngangen skal bruke Arduinoen sin interne pullup motstand
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
 
}


void loop()
{

  //Leser inngangene inn til en "bool" variabel
  bool Status_KNAPP_1 = digitalRead(Knapp1);
  bool Status_KNAPP_2 = digitalRead(Knapp2);
  bool Status_KNAPP_3 = digitalRead(Knapp3);
  bool Status_KNAPP_4 = digitalRead(Knapp4);
  bool Status_KNAPP_5 = digitalRead(Knapp5);
  bool Status_KNAPP_6 = digitalRead(Knapp6);
  bool Status_KNAPP_7 = digitalRead(Knapp7);
  bool Status_KNAPP_8 = digitalRead(Knapp8);
  bool Status_KNAPP_9 = digitalRead(Knapp9);

  //Sier at visst en av bryterene er utløst så skal "EnBryterPresset" settes til True 
  if(Status_KNAPP_1 && Status_KNAPP_2 && Status_KNAPP_3 && Status_KNAPP_4 && Status_KNAPP_5 && Status_KNAPP_6 && Status_KNAPP_7 && Status_KNAPP_8 && Status_KNAPP_9)
    {
      EnBryterPresset = true;
    }
  else
  {
    EnBryterPresset = false;
  }
  
  bool reading = !EnBryterPresset;
  
  if (last_reading!= reading){
      last_debounce_time = millis();
      published = false;
  }
  
  //Her brukes en "debounce delay", dette gjør at bryteren må være inne en viss tid før data sendes.
  //Dette blir gjort for å redusere unødvendig sending av data og for at systemet ikke skal bli ustabilt.
  if ( !published && (millis() - last_debounce_time)  > debounce_delay) {
    pushed_msg.data = reading;
    /raspberry_bot/crashSensor.publish(&pushed_msg);
    published = true;
  }

  last_reading = reading;
  
  nh.spinOnce();
}
